﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WpfSimpleSteps {
  class CustomEntityBaseType {
    public abstract partial class CustomEntityBaseType : IDataErrorInfo {
      string IDataErrorInfo.Error {
        get { return ((INotifyDataErrorInfo)this).HasErrors ? 
          "One or more of the properties have validation errors!" : ""; }
      }
      string IDataErrorInfo.this[string columnName] {
        get {
          var errors = ((INotifyDataErrorInfo)this).GetErrors(columnName);
          if (errors != null) {
            var firstError = errors.OfType<object>().FirstOrDefault();
            if (firstError != null)
              return firstError.ToString();
          }
          return "";
        }
      }
    }
  }
}
