﻿Imports System.Text
Imports IdeaBlade.EntityModel

Namespace WpfSimpleSteps
	''' <summary>
	''' Interaction logic for MainWindow.xaml
	''' </summary>
	Partial Public Class MainWindow
		Inherits Window
		Private viewModel As MainWindowViewModel

		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub EnableDisableButtons()
			firstButton.IsEnabled = viewModel.CurrentPosition > 0
			prevButton.IsEnabled = viewModel.CurrentPosition > 0
			nextButton.IsEnabled = viewModel.CurrentPosition < viewModel.Employees.Count - 1
			lastButton.IsEnabled = viewModel.CurrentPosition < viewModel.Employees.Count - 1
			addButton.IsEnabled = viewModel.Employees IsNot Nothing
			deleteButton.IsEnabled = viewModel.CurrentPosition > -1

			okButton.IsEnabled = viewModel.HasChanges
			cancelButton.IsEnabled = viewModel.HasChanges
		End Sub

		Private Sub Window_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
			viewModel = New MainWindowViewModel()
			DataContext = viewModel

			AddHandler viewModel.PropertyChanged, Sub() EnableDisableButtons()
			AddHandler viewModel.Employees.CollectionChanged, Sub() EnableDisableButtons()
		End Sub

		Private Sub firstButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			viewModel.MoveCurrentToFirst()
		End Sub

		Private Sub prevButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			viewModel.MoveCurrentToPrevious()
		End Sub

		Private Sub nextButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			viewModel.MoveCurrentToNext()
		End Sub

		Private Sub lastButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			viewModel.MoveCurrentToLast()
		End Sub

		Private Sub addButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			viewModel.AddNew()
		End Sub

		Private Sub deleteButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			If viewModel.CurrentPosition > -1 Then
				viewModel.RemoveAt(viewModel.CurrentPosition)
			End If
		End Sub

		Private Sub okButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			viewModel.Save()
		End Sub

		Private Sub cancelButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			viewModel.RollbackChanges()
		End Sub

		Private Sub OrdersGrid_AutoGeneratingColumn(ByVal sender As Object, ByVal e As DataGridAutoGeneratingColumnEventArgs)
			e.Cancel = e.PropertyName = "Customer" OrElse e.PropertyName = "OrderDetails"
		End Sub
	End Class
End Namespace
